configure 21.7 KB
Newer Older
ulrich_y's avatar
ulrich_y committed
1 2 3 4 5 6 7 8 9 10 11
#! /bin/bash
# configure script
# note: has nothing to do with GNU autoconf

exec 2> ${LOGFILE:-/dev/null} 3>&1
eval ${LOGFILE:+set -x}


shopt -s nullglob
export LC_ALL=C

ulrich_y's avatar
ulrich_y committed
12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34
printhelp() {
cat << EOF
\`configure' configures handyG to adapt to many kinds of systems.

Usage: ./configure [OPTION]... [VAR=VALUE]...

To assign environment variables (e.g., CC, CFLAGS...), specify them as
VAR=VALUE.  See below for descriptions of some of the useful variables.

Defaults for the options are specified in brackets.

Installation directories:
  --prefix=PREFIX         install files in PREFIX [/usr/]
  --mmprefix=PREFIX       install files in for Mathematica
                          [\$UserBaseDirectory/Kernel/]

By default, \`make install' will install all the files in
\`/usr/local/bin', \`/usr/local/lib' etc.  You can specify
an installation prefix other than \`/usr/local' using \`--prefix',
for instance \`--prefix=\$HOME'.

For better control, use the options below.
  --moduledir=DIR         Fortran module files (compiler specific)
ulrich_y's avatar
ulrich_y committed
35 36 37
  --quad                  uses quadruple precision (128 bit) as the
                          working precision. This is not compatible with
                          the GiNaC interface.
ulrich_y's avatar
ulrich_y committed
38 39 40 41 42 43

Fine tuning of the installation directories:

System types:
  --32                    forces 32-bit compilation
  --64                    forces 64-bit compilation
ulrich_y's avatar
ulrich_y committed
44
  --native                do optimize code for the host machine
ulrich_y's avatar
ulrich_y committed
45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73

Optional Packages:
  --with-mcc              activates Mathematica interface
  --with-ginac            activates GiNaC interface for testing
  --debug                 compile with debug flags and without optimization

Some influential environment variables:
  FC          Fortran compiler command
  FFLAGS      Fortran compiler flags
  LD          linker command
  LDFLAGS     linker flags, e.g. -L<lib dir> if you have libraries in a
              nonstandard directory <lib dir>
  CC          C compiler command
  CFLAGS      C compiler flags
  CXX         C++ compiler command
  CXXFLAGS    C++ compiler flags
  FPATH       Path to put Fortran modules
  PKG_CONFIG_PATH
              directories to add to pkg-config's search path

Use these variables to override the choices made by \`configure' or to help
it to find libraries and programs with nonstandard names/locations.

Report bugs to <yannick.ulrich@psi.ch>.

EOF
exit
}

ulrich_y's avatar
ulrich_y committed
74 75
CONF_DIR="${0%/*}"
CONF_OS="`uname -s`"
ulrich_y's avatar
ulrich_y committed
76 77 78
HAVE_GINAC=false
HAVE_MCC=false
CONF_BITS=
ulrich_y's avatar
ulrich_y committed
79

ulrich_y's avatar
ulrich_y committed
80
CONF_QUAD=false
ulrich_y's avatar
ulrich_y committed
81 82
CONF_FFLAGS=$FFLAGS
CONF_CFLAGS=$CFLAGS
ulrich_y's avatar
ulrich_y committed
83
CONF_CXXFLAGS=$CXXFLAGS
ulrich_y's avatar
ulrich_y committed
84 85 86 87 88
CONF_LFLAGS=$LDFLAGS
CONF_FC=$FC
CONF_CC=$CC
CONF_CXX=$CXX
CONF_LD=$LD
ulrich_y's avatar
ulrich_y committed
89
CONF_MODDIR=$FPATH
ulrich_y's avatar
ulrich_y committed
90 91


ulrich_y's avatar
ulrich_y committed
92 93 94 95 96 97
if [ "$CONF_OS" -eq "Darwin" ]; then
    CONF_PREFIX=/usr/local/
else
    CONF_PREFIX=/usr/
fi

ulrich_y's avatar
ulrich_y committed
98

ulrich_y's avatar
ulrich_y committed
99
allargs="$@"
ulrich_y's avatar
ulrich_y committed
100
NATIVE=false
ulrich_y's avatar
ulrich_y committed
101
DEBUG=false
ulrich_y's avatar
ulrich_y committed
102
COVERAGE=false
ulrich_y's avatar
ulrich_y committed
103 104 105 106 107 108
for arg in "$@" ; do
    case "$arg" in
        --debug)
            DEBUG=true ;;
        --prefix=*)
            CONF_PREFIX="${arg#--prefix=}" ;;
ulrich_y's avatar
ulrich_y committed
109 110
        --moduledir=*)
            CONF_MODDIR="${arg#--moduledir=}" ;;
ulrich_y's avatar
ulrich_y committed
111
        --with-ginac)
ulrich_y's avatar
ulrich_y committed
112
            HAVE_GINAC=true ;;
ulrich_y's avatar
ulrich_y committed
113
        --with-mcc)
ulrich_y's avatar
ulrich_y committed
114
            HAVE_MCC=true ;;
ulrich_y's avatar
ulrich_y committed
115 116
        --mmprefix=*)
            CONF_MMPREFIX="${arg#--mmprefix=}" ;;
ulrich_y's avatar
ulrich_y committed
117 118
        --native)
            NATIVE=true ;;
ulrich_y's avatar
ulrich_y committed
119 120 121 122
        --32)
            CONF_BITS="-m32" ;;
        --64)
            CONF_BITS="-m64" ;;
ulrich_y's avatar
ulrich_y committed
123 124
        --quad)
            CONF_QUAD=true ;;
ulrich_y's avatar
ulrich_y committed
125 126
        --coverage)
            COVERAGE=true ;;
ulrich_y's avatar
ulrich_y committed
127 128
        --help )
            printhelp ;;
ulrich_y's avatar
ulrich_y committed
129
        -*)
ulrich_y's avatar
ulrich_y committed
130 131
            echo "Warning: $arg is not a valid option." 1>&3
            printhelp ;;
ulrich_y's avatar
ulrich_y committed
132 133 134
        *=*)
            eval "$arg" ;;
        *)
ulrich_y's avatar
ulrich_y committed
135 136
            echo "Warning: $arg is not a valid argument." 1>&3
            printhelp ;;
ulrich_y's avatar
ulrich_y committed
137 138 139 140 141 142 143 144
    esac
done


test=test$$
trap "rm -fr $test* =." 0 1 2 3 15


ulrich_y's avatar
ulrich_y committed
145 146 147 148
if $COVERAGE ; then
  $DEBUG || echo "Warning: --coverage implies --debug!" 1>&3
  DEBUG=true
fi
ulrich_y's avatar
ulrich_y committed
149 150 151 152 153 154 155 156 157
## look for some programs

findprog() {
    echo -n "looking for $1... " 1>&3
    var="$2"
    set -- ${!var:+"${!var}"} "${@:3}"
    for prog in "$@" ; do
        full="`type -P "$prog"`" && {
            echo "$full" 1>&3
ulrich_y's avatar
ulrich_y committed
158
            printf -v "CONF_$var" "%q" "$full"
ulrich_y's avatar
ulrich_y committed
159 160 161 162 163 164
            return 0
        }
    done
    echo "no $@ in your path" 1>&3
    return 1
}
ulrich_y's avatar
ulrich_y committed
165 166 167 168 169 170 171 172

findlib() {
    echo -n "looking for lib$1... " 1>&3
    for flag in $CONF_LFLAGS ; do
        case "$flag" in
            -L* )
                libfolder=${flag/-L/}
                if [ -f "$libfolder/lib$1.so" ] ; then
ulrich_y's avatar
ulrich_y committed
173
                    path=`readlink -f -- "$libfolder/lib$1.so"`
ulrich_y's avatar
ulrich_y committed
174
                    echo $path 1>&3
ulrich_y's avatar
ulrich_y committed
175
                    printf -v "CONF_$2" "%q" "$path"
ulrich_y's avatar
ulrich_y committed
176 177 178
                    return 0
                fi
                if [ -f "$libfolder/lib$1.a" ] ; then
ulrich_y's avatar
ulrich_y committed
179
                    path=`readlinf -f -- "$libfolder/lib$1.a"`
ulrich_y's avatar
ulrich_y committed
180
                    echo $path 1>&3
ulrich_y's avatar
ulrich_y committed
181
                    printf -v "CONF_$2" "%q" "$path"
ulrich_y's avatar
ulrich_y committed
182 183 184 185 186 187 188 189
                    return 0
                fi
            ;;
        esac
    done
    echo "not found" 1>&3
    return 1
}
ulrich_y's avatar
ulrich_y committed
190
addflag() {
ulrich_y's avatar
ulrich_y committed
191
    eval "CONF_$1=\"\${CONF_$1} ${@:2}\""
ulrich_y's avatar
ulrich_y committed
192 193 194 195
}

gnuflags() {
    eval addflag FFLAGS -cpp                         # C pre-processor
ulrich_y's avatar
ulrich_y committed
196
    eval addflag FFLAGS -pedantic-errors -std=f2008  # folow f08 strictly
ulrich_y's avatar
ulrich_y committed
197 198
    eval addflag FFLAGS -J build                     # where to put mods
    eval addflag FFLAGS -Werror -Wall                # make every warning an error
ulrich_y's avatar
ulrich_y committed
199
    eval addflag FFLAGS -Wno-uninitialized
ulrich_y's avatar
ulrich_y committed
200
    eval addflag FFLAGS -ffree-line-length-0
ulrich_y's avatar
ulrich_y committed
201 202
}

ulrich_y's avatar
ulrich_y committed
203

ulrich_y's avatar
ulrich_y committed
204 205 206
if [ -z $FC ]; then
    findprog fortran FC  ifort gfortran  || exit 1
fi
ulrich_y's avatar
ulrich_y committed
207 208


ulrich_y's avatar
ulrich_y committed
209
set -- `eval $CONF_FC --version -c | sed '/^$/d;s/([^)]*)//;q' 2>&1`
ulrich_y's avatar
ulrich_y committed
210 211
case "$1,$2,$3" in
    GNU,Fortran,[123].*)
212
        echo "Only version >= 4 are supported" 1>&3
ulrich_y's avatar
ulrich_y committed
213 214
        exit
    ;;
ulrich_y's avatar
ulrich_y committed
215
    GNU,Fortran,4.*)
216
    echo "Code optimisation is *not* suported on gfortran 4" 1>&3
ulrich_y's avatar
ulrich_y committed
217
        gnuflags
ulrich_y's avatar
ulrich_y committed
218
        eval addflag $CONF_BITS
ulrich_y's avatar
ulrich_y committed
219 220
        if $DEBUG ; then
            eval addflag FFLAGS -g -O0
ulrich_y's avatar
ulrich_y committed
221
            eval addflag FFLAGS -ffpe-trap=invalid,overflow
ulrich_y's avatar
ulrich_y committed
222 223 224 225 226
            eval addflag FFLAGS -fdump-core -fbacktrace
            eval addflag FFLAGS -frange-check
            eval addflag FFLAGS -DDEBUG
        else
            eval addflag FFLAGS -DRELEASE
ulrich_y's avatar
ulrich_y committed
227
            $NATIVE && eval addflag FFLAGS -march=native -mtune=native
ulrich_y's avatar
ulrich_y committed
228
        fi
ulrich_y's avatar
ulrich_y committed
229 230 231 232
        if $COVERAGE ; then
            echo "Coverage analytics is currently only supported for gcc"
            exit 1
        fi
ulrich_y's avatar
ulrich_y committed
233 234 235 236
    ;;
    GNU,Fortran,*)
        gnuflags
        eval addflag FFLAGS -Wno-maybe-uninitialized
ulrich_y's avatar
ulrich_y committed
237
        eval addflag $CONF_BITS
ulrich_y's avatar
ulrich_y committed
238 239
        if $DEBUG ; then
            eval addflag FFLAGS -g -O0
ulrich_y's avatar
ulrich_y committed
240
            eval addflag FFLAGS -ffpe-trap=invalid,overflow
ulrich_y's avatar
ulrich_y committed
241 242 243 244 245
            eval addflag FFLAGS -fdump-core -fbacktrace
            eval addflag FFLAGS -fcheck=all -frange-check
            eval addflag FFLAGS -DDEBUG
        else
            eval addflag FFLAGS -DRELEASE -O3
ulrich_y's avatar
ulrich_y committed
246
            $NATIVE && eval addflag FFLAGS -march=native -mtune=native
ulrich_y's avatar
ulrich_y committed
247
        fi
ulrich_y's avatar
ulrich_y committed
248 249 250 251
        if $COVERAGE ; then
            eval addflag FFLAGS --coverage
            eval addflag LFLAGS -lgcov
        fi
ulrich_y's avatar
ulrich_y committed
252 253 254 255 256
    ;;
    ifort*)
        eval addflag FFLAGS -module build
        eval addflag FFLAGS -fpp
        eval addflag FFLAGS -stand f03
ulrich_y's avatar
ulrich_y committed
257
        eval addflag $CONF_BITS
ulrich_y's avatar
ulrich_y committed
258 259 260 261
        if $DEBUG ; then
            eval addflag FFLAGS -g -O0
            eval addflag FFLAGS -DDEBUG
        else
ulrich_y's avatar
ulrich_y committed
262 263
            eval addflag FFLAGS -DRELEASE -O3 -fast
            $NATIVE && eval addflag FFLAGS -xHost
ulrich_y's avatar
ulrich_y committed
264
        fi
ulrich_y's avatar
ulrich_y committed
265
        if $HAVE_GINAC ; then
266
            echo "Option --with-ginac is incompatible with ifort, disabling" 1>&3
ulrich_y's avatar
ulrich_y committed
267
            HAVE_GINAC=false
ulrich_y's avatar
ulrich_y committed
268
        fi
ulrich_y's avatar
ulrich_y committed
269
        if $HAVE_MCC ; then
270
            echo "Option --with-mcc is incompatible with ifort, disabling" 1>&3
ulrich_y's avatar
ulrich_y committed
271
            HAVE_MCC=false
ulrich_y's avatar
ulrich_y committed
272
        fi
ulrich_y's avatar
ulrich_y committed
273 274 275 276
        if $COVERAGE ; then
            echo "Coverage analytics is currently only supported for gcc"
            exit 1
        fi
ulrich_y's avatar
ulrich_y committed
277 278
    ;;
    *)
279
        echo "Unknown compiler" 1>&3
ulrich_y's avatar
ulrich_y committed
280 281 282 283
        exit
    ;;
esac

ulrich_y's avatar
ulrich_y committed
284 285 286 287 288 289 290 291
echo -n "extracting the Fortran libraries... " 1>&3

rm -fr $test*

tee $test.f90 << _EOF_ 1>&2
    program test
    integer i
    common /uscore/ i
ulrich_y's avatar
ulrich_y committed
292
    call exit(i)
ulrich_y's avatar
ulrich_y committed
293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315
    end
_EOF_

while read line ; do
  set -- ${line//[:,()]/ }
  [[ "$1" =~ (/collect2|/ld|^ld)$ ]] && while test $# -gt 1 ; do
    shift
    case "$1" in
    *.o | -lc*)
      ;;
    -l* | -L* | *.a)
      FLDFLAGS+=" $1" ;;
    -Bstatic | -Bdynamic | *.ld)
      FLDFLAGS+=" -Wl,$1" ;;
    /*)
      FLDFLAGS+=" -L$1" ;;
    -rpath*)
      FLDFLAGS+=" -Wl,$1,$2"
      shift ;;
    -dynamic-linker)
      shift ;;
    esac
  done
ulrich_y's avatar
ulrich_y committed
316 317 318 319 320 321 322 323 324 325 326 327

  if [[ "$line" == *"-fintrinsic-modules-path"* ]]; then
    set -- ${line//[:,()]/ }
    while test $# -gt 1 ; do
      shift
      case "$1" in
        -fintrinsic-modules-path )
          CONF_MODPATH=$2
          ;;
      esac
    done
  fi
ulrich_y's avatar
ulrich_y committed
328
done < <(eval $CONF_FC  -v -o $test $test.f90 2>&1)
ulrich_y's avatar
ulrich_y committed
329 330
echo "ok" 1>&3

ulrich_y's avatar
ulrich_y committed
331
eval addflag LFLAGS "$LDFLAGS $CONF_LDFLAGS $FLDFLAGS -L$CONF_PREFIX/lib"
ulrich_y's avatar
ulrich_y committed
332

ulrich_y's avatar
ulrich_y committed
333 334
if [[ -z "$CONF_MODDIR" ]]; then
  if [[ ! -z "$CONF_MODPATH" ]]; then
ulrich_y's avatar
ulrich_y committed
335 336 337
    echo -n "checking whether module path is in prefix... " 1>&3
    if [[ "${CONF_MODPATH##$CONF_PREFIX}" != "${CONF_MODPATH}" ]]; then
        echo " yes" 1>&3
ulrich_y's avatar
ulrich_y committed
338
        CONF_MODDIR=$CONF_MODPATH
ulrich_y's avatar
ulrich_y committed
339 340
    else
        echo " no" 1>&3
ulrich_y's avatar
ulrich_y committed
341
        CONF_MODDIR=
ulrich_y's avatar
ulrich_y committed
342
    fi
ulrich_y's avatar
ulrich_y committed
343
  fi
ulrich_y's avatar
ulrich_y committed
344 345
fi

ulrich_y's avatar
ulrich_y committed
346

347
findprog pkg-config PKGCONFIG pkg-config
ulrich_y's avatar
ulrich_y committed
348
if [[ -z "$CONF_MODDIR" ]]; then
ulrich_y's avatar
ulrich_y committed
349
  if [[ -z "$CONF_PKGCONFIG" ]]; then
350 351 352 353 354 355 356 357 358
    echo "*************************************************" 1>&3
    echo "Warning! pkg-config not found! This may lead to  " 1>&3
    echo "difficulties when you try to compile your own    " 1>&3
    echo "code. You will need to run                       " 1>&3
    echo "                                                 " 1>&3
    echo "  $CONF_FC -I$CONF_PREFIX/include                " 1>&3
    echo "                                                 " 1>&3
    echo "every time.                                      " 1>&3
    echo "*************************************************" 1>&3
ulrich_y's avatar
ulrich_y committed
359
  fi
360
fi
ulrich_y's avatar
ulrich_y committed
361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377

if ( $HAVE_GINAC || $HAVE_MCC ); then
    findprog gcc CC clang gcc || exit 1
    findprog g++ CXX clang++ g++ || exit 1
    eval addflag CFLAGS "-std=c99"

    ## does Fortran append underscores to symbols?

    echo -n "does $CONF_FC append underscores... " 1>&3

    tee $test-c.c << _EOF_ 1>&2
int uscore_ = 95;
int uscore = 59;
_EOF_

    for CONF_BITS in ${CONF_BITS:--m64 -m32} ; do
      eval $CONF_CC $CONF_CFLAGS $CONF_BITS -c $test-c.c 1>&2 || continue
ulrich_y's avatar
ulrich_y committed
378
      eval $CONF_FC  -o $test $test.f90 $test-c.o 1>&2 && break
ulrich_y's avatar
ulrich_y committed
379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398
    done

    ./$test
    case $? in
    95)
      echo "yes" 1>&3
      CONF_NOUNDERSCORE=0 ;;
    59)
      echo "no" 1>&3
      CONF_NOUNDERSCORE=1 ;;
    *)
      echo "error linking Fortran and C" 1>&3
      exit 1 ;;
    esac

else
    $CONF_CC=
    $CONF_CXX=
    $CONF_CFLAGS=
    $CONF_NOUNDERSCORE=
ulrich_y's avatar
ulrich_y committed
399 400
fi

ulrich_y's avatar
ulrich_y committed
401 402 403

if $HAVE_MCC ; then
    PATH=$PATH:/Applications/Mathematica.app/Contents/MacOS/ findprog mathematica MATH math MathKernel math10 math11
ulrich_y's avatar
ulrich_y committed
404
    eval addflag FFLAGS -DHAVE_MM
ulrich_y's avatar
ulrich_y committed
405 406 407 408 409 410 411 412

    # Checking Mathematica system id

    echo -n "what is $CONF_MATH SystemID... " 1>&3

    tee $test.m << _EOF_ 1>&2
        Print["SYSID "<>ToString[\$SystemID]];
        Print["INSTDIR "<>ToString[\$InstallationDirectory]];
ulrich_y's avatar
ulrich_y committed
413
        Print["USERDIR "<>ToString[\$UserBaseDirectory]];
ulrich_y's avatar
ulrich_y committed
414 415 416 417
_EOF_
    $CONF_MATH < $test.m > $test.log
    CONF_MATH_SYS=`cat $test.log | grep "SYSID"   | sed 's/.*SYSID //'`
    CONF_MATH_DIR=`cat $test.log | grep "INSTDIR" | sed 's/.*INSTDIR //'`
ulrich_y's avatar
ulrich_y committed
418
    CONF_MATH_USR=`cat $test.log | grep "USERDIR" | sed 's/.*USERDIR //'`
ulrich_y's avatar
ulrich_y committed
419 420
    [[ -z "$CONF_MMPREFIX" ]] && \
       CONF_MMPREFIX=${CONF_MMPREFIX:=$CONF_MATH_USR/Kernel}
ulrich_y's avatar
ulrich_y committed
421 422 423 424 425 426 427 428 429 430 431 432 433 434 435
    echo  $CONF_MATH_SYS 1>&3


    # Finding mcc
    CONF_COMPAD=$CONF_MATH_DIR/SystemFiles/Links/MathLink/DeveloperKit/$CONF_MATH_SYS/CompilerAdditions/
    PATH=$CONF_COMPAD:$PATH findprog mcc MCC mcc

    echo -n "looking for MLDK directory... " 1>&3
    $CONF_MCC --internals > $test.int
    CONF_MLDK=`cat $test.int | grep "MLDK Directory" | cut -f2 -d":"`
    echo $CONF_MLDK 1>&3

    arch=`cat $test.int | grep "Library Bit Type:" | cut -f2 -d":"` ; \
    CONF_MCC_CFLAGS=`cat $test.int | grep "Compile Flags$arch:" | cut -f2 -d":"`
    CONF_MCC_LFLAGS=`cat $test.int | grep "Linker Libraries" | cut -f2 -d":"`
ulrich_y's avatar
ulrich_y committed
436
    CONF_MCC_LFLAGS="$CONF_LFLAGS $CONF_MCC_LFLAGS"
ulrich_y's avatar
ulrich_y committed
437 438 439 440 441 442 443 444
    cat $test.int | grep "Linker Libraries" | cut -f2 -d":"
    if [ ! -z $CONF_BITS ]; then
        if [ "$CONF_BITS" -ne "$MCC_BITS" ]; then
            echo "mcc wants $MCC_BITS ($arch), $CONF_BITS selected." 1>&3
            exit 1
        fi
    fi

ulrich_y's avatar
ulrich_y committed
445
    if [[ $CONF_MCC_LFLAGS == *"uuid"* ]]; then
ulrich_y's avatar
ulrich_y committed
446 447 448 449 450 451 452 453 454 455
        if ! findlib uuid UUID ; then
            echo -n "improvising uuid... " 1>&3
            CONF_MLIBDIR=$CONF_MATH_DIR/SystemFiles/Libraries/$CONF_MATH_SYS/
            if [ -f $CONF_MLIBDIR/libuuid.a ]; then
                CONF_MCC_LFLAGS="-L$CONF_MLIBDIR $CONF_MCC_LFLAGS"
                echo "okay" 1>&3
            else
                echo "failed" 1>&3
                exit 1
            fi
ulrich_y's avatar
ulrich_y committed
456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491
        fi
    fi

    # Finding MPREP
    PATH=$CONF_COMPAD:$PATH findprog mprep MPREP mprep

    ## can we do MathLink compilations
    echo -n "do we have working MathLink... " 1>&3
    tee $test.tm << _EOF_ 1>&2
:Begin:
:Function: test
:Pattern: Test[i_Integer]
:Arguments: {i}
:ArgumentTypes: {Integer}
:ReturnType: Integer
:End:

#include "mathlink.h"

static int test(const int i) {
  return i + 1;
}

int main(int argc, char **argv) {
  return MLMain(argc, argv);
}
_EOF_
    $CONF_MPREP $test.tm > $test.tm.c
    $CONF_CC $CONF_MCC_CFLAGS $CONF_CFLAGS -c $test.tm.c
    $CONF_CC -o $test.math $test.tm.o $CONF_MCC_LFLAGS
    test -x $test.math && {
        echo "yes" 1>&3
        CONF_ML=1
    } || {
        echo "no" 1>&3
        CONF_ML=0
ulrich_y's avatar
ulrich_y committed
492
        exit 1;
ulrich_y's avatar
ulrich_y committed
493 494
    }
fi
ulrich_y's avatar
ulrich_y committed
495 496


ulrich_y's avatar
ulrich_y committed
497
CONF_LD=${LD:-$CONF_FC}
ulrich_y's avatar
ulrich_y committed
498 499


ulrich_y's avatar
ulrich_y committed
500 501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525



if $CONF_QUAD ; then
  if $HAVE_GINAC ; then
    echo "GiNaC testing is not supported for quad-precision!" 1>&3
    exit 1
  fi
  echo -n "does $CONF_FC support quad-precision... " 1>&3
  rm -fr $test*
  tee $test.f90 << _EOF_ 1>&2
        program test
        real(selected_real_kind(30,32)) a, b
        a = 2D0**(52/2+2)
        b = a + 1/a
        if( a .eq. b ) stop 1
        end
_EOF_
  $CONF_FC $CONF_FFLAGS -o $test $test.f90 1>&2
  ./$test 1>&2 && {
    echo "yes" 1>&3
    eval addflag FFLAGS -DKINDREAL=16 -DKINDINT=8
  } || {
    echo "no" 1>&3
    exit 1
  }
ulrich_y's avatar
ulrich_y committed
526
  $HAVE_MCC && eval addflag CFLAGS -DHAVE_QUAD
ulrich_y's avatar
ulrich_y committed
527 528 529 530 531 532 533
fi






ulrich_y's avatar
ulrich_y committed
534
if $HAVE_GINAC ; then
ulrich_y's avatar
ulrich_y committed
535
    eval addflag CXXFLAGS "-std=c++11"
ulrich_y's avatar
ulrich_y committed
536 537 538 539
    if [[ ! -z "$CONF_PKGCONFIG" ]]; then
        echo -n "Does pkg-config know about GiNaC... " 1>&3
        if $CONF_PKGCONFIG --exists ginac ; then
            echo "yes" 1>&3
ulrich_y's avatar
ulrich_y committed
540
            eval addflag CXXFLAGS `$CONF_PKGCONFIG --cflags ginac`
ulrich_y's avatar
ulrich_y committed
541 542
            eval addflag LFLAGS `$CONF_PKGCONFIG --libs ginac`
            FOUND_GINAC=true
ulrich_y's avatar
ulrich_y committed
543
            CONF_GINAC=`$CONF_PKGCONFIG --variable=libdir ginac`
ulrich_y's avatar
ulrich_y committed
544 545 546 547 548 549 550 551 552 553 554 555
        else
            echo "no" 1>&3
            FOUND_GINAC=false
        fi
    fi
    if ! $FOUNDGINAC ; then
        FOUNDGINAC=`findlib ginac GINAC && findlib cln CLN`
        eval addflag LFLAGS "-L`dirname $CONF_GINAC`"
        eval addflag LFLAGS "-L`dirname $CONF_CLN`"
        eval addflag LFLAGS "-lginac -lcln"
    fi
    if $FOUNDGINAC; then
ulrich_y's avatar
ulrich_y committed
556
        CONF_LD=${LD:-$CONF_CXX}
ulrich_y's avatar
ulrich_y committed
557 558 559 560 561 562 563 564 565 566 567 568 569 570 571
        echo -n "Checking if GiNaC works... " 1>&3
        tee $test.ginac.cpp << _EOF_ 1>&2
#include <ginac/ginac.h>
#include <iostream>
int main() {

    GiNaC::ex ans = GiNaC::G(0.3,0.5,0.7);
    ans -= 0.2876820724517808812+3.1415926535897932385*GiNaC::I;
    ans = GiNaC::abs(ans);
    if (ans<1e-15)
        return 0;
    else
        return 1;
}
_EOF_
ulrich_y's avatar
ulrich_y committed
572
        $CONF_CXX $CONF_CXXFLAGS $CONF_BITS -c $test.ginac.cpp
ulrich_y's avatar
ulrich_y committed
573 574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592
        $CONF_LD -o $test.ginac $test.ginac.o $CONF_LFLAGS
        ./$test.ginac
        case $? in
            0)
              echo "yes" 1>&3
              eval addflag FFLAGS "-DHAVE_GINAC" ;;
            1)
              echo "no" 1>&3
              exit 1 ;;
            *)
              echo "error running GiNaC" 1>&3
              exit 1 ;;
        esac
    else
        echo "GiNaC could not be found" 1>&3
        exit 1
    fi
fi


ulrich_y's avatar
ulrich_y committed
593 594 595
if $HAVE_GINAC && $HAVE_MCC; then
  eval addflag LFLAGS -lrt
fi
ulrich_y's avatar
ulrich_y committed
596

597 598 599 600 601 602 603 604 605 606 607
if [[ ! -z "$CONF_PKGCONFIG" ]]; then
cat > handyg.pc <<EOF
prefix=$CONF_PREFIX
exec_prefix=\${prefix}
libdir=\${exec_prefix}/lib
includedir=\${prefix}/include

Name: handyG
Description: Numerical evaluation of GPL
Version: 0.1.0
Libs: -L\${libdir} -lhandyg
ulrich_y's avatar
ulrich_y committed
608
Cflags: -I\${includedir}
609 610 611 612
EOF

fi

ulrich_y's avatar
ulrich_y committed
613 614 615 616 617 618 619 620 621 622 623 624 625 626 627 628 629 630 631 632
if $COVERAGE ; then
    findprog gcov GCOV gcov gcov-7 gcov-6 gcov-5 gcov-34 || exit 1
    if ! findlib gcov LGCOV ; then
      echo "can't perform coverage tests without libgcov. Please specify using \$LFLAGS" 1>&3
      exit 1
    fi

    if ! findprog lcov LCOV lcov ; then
      echo "graphical coverage report won't be supported" 1>&3
      HAVE_LCOV=false
    else
      if ! findprog genhtml GENHTML genhtml ; then
        echo "graphical coverage report won't be supported" 1>&3
        HAVE_LCOV=false
      else
        HAVE_LCOV=true
      fi
    fi
fi

ulrich_y's avatar
ulrich_y committed
633 634 635 636
echo "creating makefile" 1>&3


cat  > makefile <<EOF
ulrich_y's avatar
ulrich_y committed
637
# Generated through $0 $allargs on `date` by `whoami`
ulrich_y's avatar
ulrich_y committed
638 639 640 641 642 643 644

AR=ar rcs
FC=$CONF_FC
CC=$CONF_CC
CXX=$CONF_CXX
LD=$CONF_LD
MPREP=$CONF_MPREP
ulrich_y's avatar
ulrich_y committed
645
MATH=$CONF_MATH
ulrich_y's avatar
ulrich_y committed
646 647 648
GCOV=$CONF_GCOV
LCOV=$CONF_LCOV
GENHTML=$CONF_GENHTML
ulrich_y's avatar
ulrich_y committed
649 650 651

FFLAGS=$CONF_FFLAGS
CFLAGS=$CONF_CFLAGS
ulrich_y's avatar
ulrich_y committed
652
CXXFLAGS=$CONF_CXXFLAGS
ulrich_y's avatar
ulrich_y committed
653 654 655 656
LFLAGS=$CONF_LFLAGS
MCFLAGS=$CONF_MCC_CFLAGS
MLFLAGS=$CONF_MCC_LFLAGS

ulrich_y's avatar
ulrich_y committed
657 658
PREFIX=$CONF_PREFIX
MMPREFIX=$CONF_MMPREFIX
ulrich_y's avatar
ulrich_y committed
659
MODDIR=$CONF_MODDIR
ulrich_y's avatar
ulrich_y committed
660

ulrich_y's avatar
ulrich_y committed
661

ulrich_y's avatar
ulrich_y committed
662
files=globals.o ieps.o utils.o shuffle.o maths_functions.o mpl_module.o gpl_module.o handyG.o
ulrich_y's avatar
ulrich_y committed
663 664 665
objects = \$(addprefix build/,\$(files))


ulrich_y's avatar
ulrich_y committed
666
all: libhandyg.a handyg.mod ${CONF_MPREP:+handyG} geval test
ulrich_y's avatar
ulrich_y committed
667

ulrich_y's avatar
ulrich_y committed
668
libhandyg.a:\$(objects)
ulrich_y's avatar
ulrich_y committed
669
		@echo "AR \$@"
ulrich_y's avatar
ulrich_y committed
670 671 672 673 674
		@\$(AR) \$@ \$^

handyg.mod: build/handyg.mod
		cp \$< \$@

ulrich_y's avatar
ulrich_y committed
675 676 677 678

# rules to make object files into /build
build/%.o: src/%.f90
		@echo "F90 \$@"
ulrich_y's avatar
ulrich_y committed
679
		@\$(FC) \$(FFLAGS) -c \$< -o \$@
ulrich_y's avatar
ulrich_y committed
680

ulrich_y's avatar
ulrich_y committed
681 682
build/%.o: checks/%.f90
		@echo "F90 \$@"
ulrich_y's avatar
ulrich_y committed
683
		@\$(FC) \$(FFLAGS) -c \$< -o \$@
ulrich_y's avatar
ulrich_y committed
684

ulrich_y's avatar
ulrich_y committed
685 686
build/%.o: src/%.cpp
		@echo "C++ \$@"
ulrich_y's avatar
ulrich_y committed
687
		@\$(CC) \$(CXXFLAGS) -c \$<  -o \$@
ulrich_y's avatar
ulrich_y committed
688

ulrich_y's avatar
ulrich_y committed
689
geval: libhandyg.a build/geval.o
ulrich_y's avatar
ulrich_y committed
690
		@echo "LD \$@"
ulrich_y's avatar
ulrich_y committed
691
		@\$(LD) -o \$@ build/geval.o -L. -lhandyg \$(LFLAGS)
ulrich_y's avatar
ulrich_y committed
692

ulrich_y's avatar
ulrich_y committed
693 694 695 696 697
EOF

$HAVE_MCC && cat >> makefile <<EOF
build/%.tm.c: src/%.tm
		@echo "MPREP \$@"
ulrich_y's avatar
ulrich_y committed
698
		@cat \$< | sed '/:Begin:/,/:End:/ s/Real/Real$($CONF_QUAD && echo 128)/g' | \$(MPREP) > \$@
ulrich_y's avatar
ulrich_y committed
699

ulrich_y's avatar
ulrich_y committed
700
build/mathlink.o: build/mathlink.tm.c
ulrich_y's avatar
ulrich_y committed
701 702 703
		@echo "CC \$<"
		@\$(CC) \$(MCFLAGS) \$(CFLAGS) -o \$@ -c \$<

ulrich_y's avatar
ulrich_y committed
704
handyG: build/mathlink.o libhandyg.a
ulrich_y's avatar
ulrich_y committed
705
		@echo "LD \$@"
ulrich_y's avatar
ulrich_y committed
706
		@\$(LD)  \$< libhandyg.a -o \$@ \$(LFLAGS) \$(MLFLAGS)
ulrich_y's avatar
ulrich_y committed
707

ulrich_y's avatar
ulrich_y committed
708 709 710
checks/test-chen.f90: checks/generate.m
		@echo "MATH generate \$@"
		@\$(MATH) -script \$< \$@
ulrich_y's avatar
ulrich_y committed
711
checks/test-chenff.f90: checks/generate.m
ulrich_y's avatar
ulrich_y committed
712 713
		@echo "MATH generate \$@"
		@\$(MATH) -script \$< \$@
ulrich_y's avatar
ulrich_y committed
714 715 716 717 718 719
checks/test-muone.f90: checks/generate.m
		@echo "MATH generate \$@"
		@\$(MATH) -script \$< \$@
checks/test-muoneNP.f90: checks/generate.m
		@echo "MATH generate \$@"
		@\$(MATH) -script \$< \$@
ulrich_y's avatar
ulrich_y committed
720 721


ulrich_y's avatar
ulrich_y committed
722 723 724 725 726 727
EOF
echo -n "test: \$(objects) " >> makefile

                            echo -n "build/test-chenref.o " >> makefile
$HAVE_GINAC              && echo -n "build/ginac.o " >> makefile
$HAVE_GINAC && $HAVE_MCC && echo -n "build/test-chen.o " >> makefile
ulrich_y's avatar
ulrich_y committed
728
$HAVE_GINAC && $HAVE_MCC && echo -n "build/test-chenff.o " >> makefile
ulrich_y's avatar
ulrich_y committed
729 730
$HAVE_GINAC && $HAVE_MCC && echo -n "build/test-muone.o " >> makefile
$HAVE_GINAC && $HAVE_MCC && echo -n "build/test-muoneNP.o " >> makefile
ulrich_y's avatar
ulrich_y committed
731

ulrich_y's avatar
ulrich_y committed
732 733
echo "build/test.o" >> makefile
cat  >> makefile <<EOF
ulrich_y's avatar
ulrich_y committed
734
		@echo "LD \$@"
ulrich_y's avatar
ulrich_y committed
735
		@\$(LD) -o \$@ \$^ \$(LFLAGS)
ulrich_y's avatar
ulrich_y committed
736

ulrich_y's avatar
ulrich_y committed
737
install: libhandyg.a handyg.mod ${CONF_MPREP:+handyg} geval
ulrich_y's avatar
ulrich_y committed
738
		mkdir -p \$(PREFIX)
ulrich_y's avatar
ulrich_y committed
739
		mkdir -p \$(PREFIX)/bin
ulrich_y's avatar
ulrich_y committed
740
		cp geval \$(PREFIX)/bin/geval
ulrich_y's avatar
ulrich_y committed
741
		mkdir -p \$(PREFIX)/lib
ulrich_y's avatar
ulrich_y committed
742
		cp libhandyg.a \$(PREFIX)/lib/
ulrich_y's avatar
ulrich_y committed
743
		mkdir -p \$(PREFIX)/include
ulrich_y's avatar
ulrich_y committed
744
		cp handyg.mod \$(PREFIX)/include/
ulrich_y's avatar
ulrich_y committed
745 746 747
EOF
$HAVE_MCC && cat >> makefile <<EOF
		mkdir -p \$(MMPREFIX)
ulrich_y's avatar
ulrich_y committed
748
		cp handyg \$(MMPREFIX)
ulrich_y's avatar
ulrich_y committed
749
EOF
750 751 752 753 754 755
if [[ ! -z "$CONF_PKGCONFIG" ]]; then
cat >> makefile <<EOF
		mkdir -p \$(PREFIX)/lib/pkgconfig
		cp handyg.pc \$(PREFIX)/lib/pkgconfig
EOF
fi
ulrich_y's avatar
ulrich_y committed
756
if [[ ! -z "$CONF_MODDIR" ]]; then
ulrich_y's avatar
ulrich_y committed
757
cat >> makefile <<EOF
ulrich_y's avatar
ulrich_y committed
758
		mkdir -p \$(MODDIR)
ulrich_y's avatar
ulrich_y committed
759
		cp handyg.mod \$(MODDIR)
ulrich_y's avatar
ulrich_y committed
760 761 762
EOF
fi

ulrich_y's avatar
ulrich_y committed
763 764 765

echo "uninstall:" >> makefile
echo -ne "\t\trm -i " >> makefile
ulrich_y's avatar
ulrich_y committed
766 767
echo -n "\$(PREFIX)/lib/libhandyg.a " >> makefile
echo -n "\$(PREFIX)/include/handyg.mod " >> makefile
ulrich_y's avatar
ulrich_y committed
768
echo -n "\$(PREFIX)/bin/geval " >> makefile
ulrich_y's avatar
ulrich_y committed
769
$HAVE_MCC && echo -n "\$(MMPREFIX)/handyg" >> makefile
770 771 772
if [[ ! -z "$CONF_PKGCONFIG" ]]; then
echo -n "\$(PREFIX)/lib/pkgconfig " >> makefile
fi
ulrich_y's avatar
ulrich_y committed
773 774
if [[ ! -z "$CONF_MODDIR" ]]; then
echo -n "\$(MODDIR)/handyg.mod " >> makefile
ulrich_y's avatar
ulrich_y committed
775
fi
ulrich_y's avatar
ulrich_y committed
776 777 778
cat  >> makefile <<EOF


ulrich_y's avatar
ulrich_y committed
779 780
check: test
		./$<
ulrich_y's avatar
ulrich_y committed
781 782 783 784 785 786 787 788 789 790 791 792 793 794 795 796 797 798 799 800 801 802 803 804 805 806 807 808 809 810 811
EOF


if $COVERAGE ; then
  cat  >> makefile <<EOF
report/report.txt: test
		mkdir -p report
		./test -verb 1000 > /dev/null
		echo "Report generated on \`date\` by `whoami`." > \$@
EOF

  for i in gpl_module ieps maths_functions mpl_module shuffle utils test
  do
    echo -e "\t\t\$(GCOV) build/$i.gcno >> \$@" >> makefile
    echo -e "\t\tmv $i.f90.gcov report/" >> makefile
  done

  $HAVE_LCOV && cat >> makefile <<EOF
report/coverage.info: report/report.txt
		\$(LCOV) --capture --directory build/ --output-file \$@
report/lcov.report: report/coverage.info
		\$(LCOV) --list \$< > \$@
		cat \$@
report/index.html: report/coverage.info
		\$(GENHTML) \$< --output-directory report
EOF
#cat \$@ | perl -nle "print \\\$\$1 if /Total:\\|(\\d+\\.?\\d+\\%)/"
  echo -n "coverage: report/report.txt" >> makefile
  $HAVE_LCOV && echo -n " report/coverage.info report/lcov.report report/index.html" >> makefile
  echo >> makefile

ulrich_y's avatar
ulrich_y committed
812

ulrich_y's avatar
ulrich_y committed
813 814 815 816

fi

cat  >> makefile <<EOF
ulrich_y's avatar
ulrich_y committed
817
clean:
ulrich_y's avatar
ulrich_y committed
818
		@rm -f build/*.gcda build/*.gcno build/*.gcov
ulrich_y's avatar
ulrich_y committed
819
		@rm -rf report/
ulrich_y's avatar
ulrich_y committed
820
		@rm -f build/*.o build/*.mod build/*.c build/mcc.internals*
ulrich_y's avatar
ulrich_y committed
821
		@rm -f test geval libhandyg.a handyG handyg.mod
ulrich_y's avatar
ulrich_y committed
822
		@rm -f checks/test-chen.f90 checks/test-muone.f90 checks/test-muoneNP.f90
ulrich_y's avatar
ulrich_y committed
823 824

distclean:
ulrich_y's avatar
ulrich_y committed
825
		@rm -f build/*.gcda build/*.gcno build/*.gcov
ulrich_y's avatar
ulrich_y committed
826
		@rm -rf report/
ulrich_y's avatar
ulrich_y committed
827
		@rm -f build/*.o build/*.mod build/*.c build/mcc.internals*
ulrich_y's avatar
ulrich_y committed
828
		@rm -f test geval libhandyg.a handyg
ulrich_y's avatar
ulrich_y committed
829
		@rm -f checks/test-chen.f90 checks/test-muone.f90 checks/test-muoneNP.f90
830
		@rm -f makefile handyg.pc
ulrich_y's avatar
ulrich_y committed
831
EOF